package hideandseek.custommaps;

import java.util.Iterator;
import org.bukkit.map.MapFont;
import org.bukkit.map.MinecraftFont;
import org.bukkit.entity.Player;
import org.bukkit.map.MapCanvas;
import org.bukkit.map.MapView;
import hideandseek.utils.Utils;
import javax.imageio.ImageIO;
import java.net.URL;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.plugin.java.JavaPlugin;
import java.awt.Image;
import java.util.List;
import org.bukkit.map.MapRenderer;

public class CombinedMapRenderer extends MapRenderer
{
    List<String> texts;
    Image image;
    
    public CombinedMapRenderer(final JavaPlugin var1, final List<String> var2, final String var3, final boolean var4) {
        this.texts = var2;
        if (var3 != null && !var3.isEmpty()) {
            if (var4) {
                new BukkitRunnable() {
                    public void run() {
                        CombinedMapRenderer.this.loadImage(var3);
                    }
                }.runTaskAsynchronously((Plugin)var1);
            }
            else {
                this.loadImage(var3);
            }
        }
    }
    
    private void loadImage(final String var1) {
        try {
            final int var2 = this.texts.isEmpty() ? 128 : 64;
            this.image = ImageIO.read(new URL(var1)).getScaledInstance(var2, var2, 4);
        }
        catch (final Exception var3) {
            Utils.error("无法加载图片 " + var1 + " in config.yml. 请尝试更换图片或图片服务器.");
        }
    }
    
    public void render(final MapView var1, final MapCanvas var2, final Player var3) {
        int var4 = 1;
        for (final String var6 : this.texts) {
            var2.drawText(25, var4++ * 10, (MapFont)MinecraftFont.Font, var6);
        }
        if (this.image != null) {
            if (!this.texts.isEmpty()) {
                var2.drawImage(32, var4 * 10 + 10, this.image);
            }
            else {
                var2.drawImage(0, 0, this.image);
            }
        }
    }
}
